//
//  ViewController.swift
//  URLSessionDemo
//
//  Created by Sarah Abraham on 9/28/16.
//  Copyright © 2016 Sarah Abraham. All rights reserved.
//

import UIKit

class ViewController: UIViewController, ExampleDataProtocol {
    @IBOutlet weak var button: UIButton!
    @IBOutlet weak var titleLabel: UILabel!
    @IBOutlet weak var bodyTextView: UITextView!
    
    var dataSession = ExampleDataSession()

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        self.dataSession.delegate = self
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func buttonClicked(sender: UIButton) {
        //Select an entry at random for display
        let entry:Int = 101//Int(arc4random_uniform(100))
        
        self.dataSession.getData(exampleDataNumber: String(entry))
    }
    
    //MARK: Example Data Protocol
    
    func responseDataHandler(data:NSDictionary) {
        let title = data["title"] as! String
        let body = data["body"] as! String
        
        //Run this handling on a separate thread
        DispatchQueue.main.async() {
            self.titleLabel.text = title
            self.bodyTextView.text = body
        }
    }

    func responseError(message:String) {
        //Run this handling on a separate thread
        DispatchQueue.main.async() {
            self.titleLabel.text = "Error!"
            self.bodyTextView.text = message
        }
    }
    

}

